access.hpp File Reference

Access control, default construction, and serialization disambiguation. More...

`#include <type_traits>`
`#include <iostream>`
`#include <cstdint>`
`#include <functional>`
`#include <cereal/macros.hpp>`
`#include <cereal/details/helpers.hpp>`

Go to the source code of this file.

## Classes

struct | cereal::LoadAndConstruct< T >
| A class that allows cereal to load smart pointers to types that have no default constructor. More...
class | cereal::construct< T >
| Used to construct types with no default constructor. More...
class | cereal::access
| A class that can be made a friend to give cereal access to non public functions. More...
struct | cereal::specialize< Archive, T, S >
| A class used to disambiguate cases where cereal cannot detect a unique way of serializing a class. More...

## Macros

#define | CEREAL_SPECIALIZE_FOR_ALL_ARCHIVES(Type, Specialization) namespace cereal { template <class Archive> struct specialize<Archive, Type, Specialization> {}; }
| Convenient macro for performing specialization for all archive types. More...
#define | CEREAL_SPECIALIZE_FOR_ARCHIVE(Archive, Type, Specialization) namespace cereal { template <> struct specialize<Archive, Type, Specialization> {}; }
| Convenient macro for performing specialization for a single archive type. More...

## Detailed Description

Access control, default construction, and serialization disambiguation.